//Copyright © 2015, Oracle and/or its affiliates. All rights reserved.

package resource;

import javax.ws.rs.Consumes;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.PUT;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.core.MediaType;

import resource.Employee.Employees;

@Path("employees")
public class EmployeeResource {
	@GET
	@Produces(MediaType.APPLICATION_JSON)
	public Employees listEmployees() {
		Iterable<Employee> employees = HRMockDB.INSTANCE.getEmployees();
		return new Employees(employees);
	}

	@GET
	@Path("{id}")
	@Produces(MediaType.APPLICATION_JSON)
	public Employee getEmployee(@PathParam("id") int id) {
		return HRMockDB.INSTANCE.getEmployee(id);
	}
	
	@POST
	@Consumes(MediaType.APPLICATION_JSON)
	@Produces(MediaType.APPLICATION_JSON)
	public Employee createEmployee(Employee employee) throws Exception {
		if (employee != null) {
			return HRMockDB.INSTANCE.createEmployee(employee);
		}
		return null;
	}
	
	@PUT
	@Path("{id}")
	@Consumes(MediaType.APPLICATION_JSON)
	@Produces(MediaType.APPLICATION_JSON)
	public Employee updateEmployee(@PathParam("id") int employeeId, Employee employee) throws Exception {
		if (employee != null) {
			return HRMockDB.INSTANCE.updateEmployee(employeeId, employee);
		}
		return null;
	}
}
